/**
 *  @file       EffectedPurrBreathing.ck
 *
 *  @author     Colin Sullivan <colinsul [at] gmail.com>
 *
 *              Copyright (c) 2012 Colin Sullivan
 *              Licensed under the MIT license.
 **/

/**
 *  @class      
 *  @extends    Sampler
 **/
public class EffectedPurrBreathing extends Sampler {

    SinOsc ph => blackhole;
    ph.phase(3*pi/2); // Start ascending

    // for(0 => int i; i < mChannels; i++) {
    //     outputs[i].compress();
    // }

    gain(1.5);

    ph.gain(0.5);

    fun void modulator_freq(float aFreq) {
        ph.freq(aFreq);
    }

    fun void modulate_phase() {
        while(true) {
            // _buf.pos(ph.last()+_buf.pos());
            ph.last() + 0.5 => _buf.rate;

            1::samp => now;
        }
    }


    path("./sounds/Cat and Amy - Purr Breathing Repetitive.aif");

    spork ~ modulate_phase();

}