/**
 *  @file       FilteredSampler.ck
 *
 *  @author     Colin Sullivan <colinsul [at] gmail.com>
 *
 *              Copyright (c) 2012 Colin Sullivan
 *              Licensed under the MIT license.
 **/

/**
 *  @class      A sampler subclass with filtering.
 *  @extends    Sampler
 **/
public class FilteredSampler extends Sampler {

    _buf =< outputsAll;
    _buf => LPF filter => outputsAll;

    fun float filterFreq(float aFreq) {
        return filter.freq(aFreq);
    }
    fun float filterQ(float aQ) {
        return filter.Q(aQ);
    }

}